# -*- coding:Utf-8 -*-
#!/usr/bin/python

# \copyleft Denis LE FUR \copyright
# This work may be distributed and/or mofified under the conditions
# or the LaTeX Project Public Licence, either v1.3 or (at your option)
# any later version. The latest version is in
#   http://www.latex-project.org/lppl/
# This work consists of the file pointlibre.py.


import pygtk
pygtk.require("2.0")
import gtk  

import os
import sys

import platform
if platform.system=="Linux" :
    sys.path.append("../SystemeLinux/")
else :
    sys.path.append("../SystemeWindows/")
from pro_sortie import *

sys.path.append("../Divers/")
from pro_divers import *




class Pointlibre:

    #-------------------------------------------------------------
    # Initialisations, création de la fenêtre principale
    #-------------------------------------------------------------
    def __init__(self,parent):
        self.parent=parent
        interface = gtk.Builder()
        interface.add_from_file('../Divers/pointlibre.glade')
        self.windowPL=interface.get_object("windowPL")
        self.checkbuttonPL1 = interface.get_object("checkbuttonPL1")
        self.checkbuttonPL2= interface.get_object("checkbuttonPL2")
        self.checkbuttonPL3 = interface.get_object("checkbuttonPL3")
        self.checkbuttonPL4 = interface.get_object("checkbuttonPL4")
        self.checkbuttonPL5 = interface.get_object("checkbuttonPL5")
        
        self.entryPL1 = interface.get_object("entryPL1")
        self.entryPL2 = interface.get_object("entryPL2")
        self.entryPL3 = interface.get_object("entryPL3")
        self.entryPL4 = interface.get_object("entryPL4")
        self.entryPL5 = interface.get_object("entryPL5")
        
        self.entryXPL1 = interface.get_object("entryXPL1")
        self.entryXPL2 = interface.get_object("entryXPL2")
        self.entryXPL3 = interface.get_object("entryXPL3")
        self.entryXPL4 = interface.get_object("entryXPL4")
        self.entryXPL5 = interface.get_object("entryXPL5")
        
        self.entryYPL1 = interface.get_object("entryYPL1")
        self.entryYPL2 = interface.get_object("entryYPL2")
        self.entryYPL3 = interface.get_object("entryYPL3")
        self.entryYPL4 = interface.get_object("entryYPL4")
        self.entryYPL5 = interface.get_object("entryYPL5")
        
        self.comboboxCouleurPL1 = interface.get_object("comboboxCouleurPL1")
        self.comboboxCouleurPL2 = interface.get_object("comboboxCouleurPL2")
        self.comboboxCouleurPL3 = interface.get_object("comboboxCouleurPL3")
        self.comboboxCouleurPL4 = interface.get_object("comboboxCouleurPL4")
        self.comboboxCouleurPL5 = interface.get_object("comboboxCouleurPL5")
        
        self.comboboxPositionPL1 = interface.get_object("comboboxPositionPL1")
        self.comboboxPositionPL2 = interface.get_object("comboboxPositionPL2")
        self.comboboxPositionPL3 = interface.get_object("comboboxPositionPL3")
        self.comboboxPositionPL4 = interface.get_object("comboboxPositionPL4")
        self.comboboxPositionPL5 = interface.get_object("comboboxPositionPL5")


        
        #Indique si la compilation est lancée
        self.Etat_Compilation=False
        
        interface.connect_signals(self)

        #Couleur par défaut : noir
        self.comboboxCouleurPL1.set_active(2)
        self.comboboxCouleurPL2.set_active(2)
        self.comboboxCouleurPL3.set_active(2)
        self.comboboxCouleurPL4.set_active(2)
        self.comboboxCouleurPL5.set_active(2)
        
        #Position par défaut : haut
        self.comboboxPositionPL1.set_active(0)
        self.comboboxPositionPL2.set_active(0)
        self.comboboxPositionPL3.set_active(0)
        self.comboboxPositionPL4.set_active(0)
        self.comboboxPositionPL5.set_active(0)
        
        #désactivation
        self.comboboxCouleurPL1.set_sensitive(False)
        self.comboboxPositionPL1.set_sensitive(False)
        self.entryPL1.set_sensitive(False)
        self.entryXPL1.set_sensitive(False)
        self.entryYPL1.set_sensitive(False)
        
        self.comboboxCouleurPL2.set_sensitive(False)
        self.comboboxPositionPL2.set_sensitive(False)
        self.entryPL2.set_sensitive(False)
        self.entryXPL2.set_sensitive(False)
        self.entryYPL2.set_sensitive(False)
        
        self.comboboxCouleurPL3.set_sensitive(False)
        self.comboboxPositionPL3.set_sensitive(False)
        self.entryPL3.set_sensitive(False)
        self.entryXPL3.set_sensitive(False)
        self.entryYPL3.set_sensitive(False)

        self.comboboxCouleurPL4.set_sensitive(False)
        self.comboboxPositionPL4.set_sensitive(False)
        self.entryPL4.set_sensitive(False)
        self.entryXPL4.set_sensitive(False)
        self.entryYPL4.set_sensitive(False)

        self.comboboxCouleurPL5.set_sensitive(False)
        self.comboboxPositionPL5.set_sensitive(False)
        self.entryPL5.set_sensitive(False)
        self.entryXPL5.set_sensitive(False)
        self.entryYPL5.set_sensitive(False)

    #-------------------------------------------------------------  
    # Fin de l'application  
    #-------------------------------------------------------------
    def on_windowPL_destroy(self, widget):
        gtk.main_quit()
        #self.windowPL.hide()
        #self.parent.set_active(False)
        
    #-------------------------------------------------------------
    # Met à jour le code à insérer
    #-------------------------------------------------------------  
    def maj_codepointlibre(self):
        Texte_Code=""
        if self.checkbuttonPL1.get_active()==True:
                PL=self.entryPL1.get_text()
                PL=traiter_texte(PL)
                XPL=self.entryXPL1.get_text()
                YPL=self.entryYPL1.get_text()
                Couleur=self.comboboxCouleurPL1.get_active_text()
                Position=self.comboboxPositionPL1.get_active_text()
                Texte_Code=Texte_Code+"[\"point-libre\",["+XPL+","+YPL+"],\"$"+PL+"$\",\""+Nom_Position(Position)+"\",\""+Nom_Couleur(Couleur)+"\",[\"xy\"]],\n"
                
        #---------------------------2
        if self.checkbuttonPL2.get_active()==True:
                PL=self.entryPL2.get_text()
                PL=traiter_texte(PL)
                XPL=self.entryXPL2.get_text()
                YPL=self.entryYPL2.get_text()
                Couleur=self.comboboxCouleurPL2.get_active_text()
                Position=self.comboboxPositionPL2.get_active_text()
                Texte_Code=Texte_Code+"[\"point-libre\",["+XPL+","+YPL+"],\"$"+PL+"$\",\""+Nom_Position(Position)+"\",\""+Nom_Couleur(Couleur)+"\",[\"xy\"]],\n"
                
        #---------------------------3
        if self.checkbuttonPL3.get_active()==True:
                PL=self.entryPL3.get_text()
                PL=traiter_texte(PL)
                XPL=self.entryXPL3.get_text()
                YPL=self.entryYPL3.get_text()
                Couleur=self.comboboxCouleurPL3.get_active_text()
                Position=self.comboboxPositionPL3.get_active_text()
                Texte_Code=Texte_Code+"[\"point-libre\",["+XPL+","+YPL+"],\"$"+PL+"$\",\""+Nom_Position(Position)+"\",\""+Nom_Couleur(Couleur)+"\",[\"xy\"]],\n"
                
        #---------------------------4
        if self.checkbuttonPL4.get_active()==True:
                PL=self.entryPL4.get_text()
                PL=traiter_texte(PL)
                XPL=self.entryXPL4.get_text()
                YPL=self.entryYPL4.get_text()
                Couleur=self.comboboxCouleurPL4.get_active_text()
                Position=self.comboboxPositionPL4.get_active_text()
                Texte_Code=Texte_Code+"[\"point-libre\",["+XPL+","+YPL+"],\"$"+PL+"$\",\""+Nom_Position(Position)+"\",\""+Nom_Couleur(Couleur)+"\",[\"xy\"]],\n"
                
        #---------------------------5
        if self.checkbuttonPL5.get_active()==True:
                PL=self.entryPL5.get_text()
                PL=traiter_texte(PL)
                XPL=self.entryXPL5.get_text()
                YPL=self.entryYPL5.get_text()
                Couleur=self.comboboxCouleurPL5.get_active_text()
                Position=self.comboboxPositionPL5.get_active_text()
                Texte_Code=Texte_Code+"[\"point-libre\",["+XPL+","+YPL+"],\"$"+PL+"$\",\""+Nom_Position(Position)+"\",\""+Nom_Couleur(Couleur)+"\",[\"xy\"]],\n"
                    
        
        
        self.Texte_Point_Libre=Texte_Code
        if self.parent.initialisation==False:
            self.parent.maj_codeprofessor()

    #-------------------------------------------------------------
    # Mise à jour après des changements dans la définition des textes
    #-------------------------------------------------------------      
    
    def on_checkbuttonPL1_clicked(self,widget):
        self.maj_codepointlibre()
        if self.checkbuttonPL1.get_active()==True:
            self.entryPL1.set_sensitive(True)
            self.entryXPL1.set_sensitive(True)
            self.entryYPL1.set_sensitive(True)
            self.comboboxCouleurPL1.set_sensitive(True)
            self.comboboxPositionPL1.set_sensitive(True)
        else:
            self.entryPL1.set_sensitive(False)
            self.entryXPL1.set_sensitive(False)
            self.entryYPL1.set_sensitive(False)
            self.comboboxCouleurPL1.set_sensitive(False)
            self.comboboxPositionPL1.set_sensitive(False)
        self.Etat_Compilation=False
        
    def on_entryPL1_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False
        
    def on_entryXPL1_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False 
        
    def on_entryYPL1_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False
        
    def on_comboboxCouleurPL1_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False
        
    def on_comboboxPositionPL1_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False 
        
    #---------------------------------- 2
        
    def on_checkbuttonPL2_clicked(self,widget):
        self.maj_codepointlibre()
        if self.checkbuttonPL2.get_active()==True:
            self.entryPL2.set_sensitive(True)
            self.entryXPL2.set_sensitive(True)
            self.entryYPL2.set_sensitive(True)
            self.comboboxCouleurPL2.set_sensitive(True)
            self.comboboxPositionPL2.set_sensitive(True)
        else:
            self.entryPL2.set_sensitive(False)
            self.entryXPL2.set_sensitive(False)
            self.entryYPL2.set_sensitive(False)
            self.comboboxCouleurPL2.set_sensitive(False)
            self.comboboxPositionPL2.set_sensitive(False)
        self.Etat_Compilation=False
        
    def on_entryPL2_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False
        
    def on_entryXPL2_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False 
        
    def on_entryYPL2_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False
        
    def on_comboboxCouleurPL2_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False
        
    def on_comboboxPositionPL2_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False 
        
    #---------------------------------- 3
        
    def on_checkbuttonPL3_clicked(self,widget):
        self.maj_codepointlibre()
        if self.checkbuttonPL3.get_active()==True:
            self.entryPL3.set_sensitive(True)
            self.entryXPL3.set_sensitive(True)
            self.entryYPL3.set_sensitive(True)
            self.comboboxCouleurPL3.set_sensitive(True)
            self.comboboxPositionPL3.set_sensitive(True)
        else:
            self.entryPL3.set_sensitive(False)
            self.entryXPL3.set_sensitive(False)
            self.entryYPL3.set_sensitive(False)
            self.comboboxCouleurPL3.set_sensitive(False)
            self.comboboxPositionPL3.set_sensitive(False)
        self.Etat_Compilation=False
        
    def on_entryPL3_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False
        
    def on_entryXPL3_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False 
        
    def on_entryYPL3_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False
        
    def on_comboboxCouleurPL3_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False
        
    def on_comboboxPositionPL3_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False 
        
    #---------------------------------- 4
        
    def on_checkbuttonPL4_clicked(self,widget):
        self.maj_codepointlibre()
        if self.checkbuttonPL4.get_active()==True:
            self.entryPL4.set_sensitive(True)
            self.entryXPL4.set_sensitive(True)
            self.entryYPL4.set_sensitive(True)
            self.comboboxCouleurPL4.set_sensitive(True)
            self.comboboxPositionPL4.set_sensitive(True)
        else:
            self.entryPL4.set_sensitive(False)
            self.entryXPL4.set_sensitive(False)
            self.entryYPL4.set_sensitive(False)
            self.comboboxCouleurPL4.set_sensitive(False)
            self.comboboxPositionPL4.set_sensitive(False)
        self.Etat_Compilation=False
        
    def on_entryPL4_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False
        
    def on_entryXPL4_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False 
        
    def on_entryYPL4_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False
        
    def on_comboboxCouleurPL4_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False
        
    def on_comboboxPositionPL4_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False 
        
    #---------------------------------- 5
        
    def on_checkbuttonPL5_clicked(self,widget):
        self.maj_codepointlibre()
        if self.checkbuttonPL5.get_active()==True:
            self.entryPL5.set_sensitive(True)
            self.entryXPL5.set_sensitive(True)
            self.entryYPL5.set_sensitive(True)
            self.comboboxCouleurPL5.set_sensitive(True)
            self.comboboxPositionPL5.set_sensitive(True)
        else:
            self.entryPL5.set_sensitive(False)
            self.entryXPL5.set_sensitive(False)
            self.entryYPL5.set_sensitive(False)
            self.comboboxCouleurPL5.set_sensitive(False)
            self.comboboxPositionPL5.set_sensitive(False)
        self.Etat_Compilation=False
        
    def on_entryPL5_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False
        
    def on_entryXPL5_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False 
        
    def on_entryYPL5_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False
        
    def on_comboboxCouleurPL5_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False
        
    def on_comboboxPositionPL5_changed(self,widget):
        self.maj_codepointlibre()
        self.Etat_Compilation=False 
        

                
        

            
#-------------------------------------------------------------          
#-------------------------------------------------------------      
# Boucle principale
#-------------------------------------------------------------
#-------------------------------------------------------------
if __name__ == "__main__":
    Pointlibre()
    gtk.main()

